package hohserg.endercompass.network;

import hohserg.elegant.networking.impl.ISerializer;
import hohserg.elegant.networking.impl.SerializerMark;
import io.netty.buffer.ByteBuf;
import net.minecraft.util.math.BlockPos;

@SerializerMark(
    packetClass = hohserg.endercompass.network.PacketSyncStrongholdPos.class
)
public class PacketSyncStrongholdPosSerializer implements ISerializer<PacketSyncStrongholdPos> {
  public void serialize(PacketSyncStrongholdPos value, ByteBuf acc) {
    serialize_PacketSyncStrongholdPos_Concretic(value, acc);
  }

  public PacketSyncStrongholdPos unserialize(ByteBuf buf) {
    return unserialize_PacketSyncStrongholdPos_Concretic(buf);
  }

  public int packetId() {
    return 1;
  }

  void serialize_PacketSyncStrongholdPos_Generic(PacketSyncStrongholdPos value, ByteBuf acc) {
    if (false)  {
      return;
    } else if (value instanceof PacketSyncStrongholdPos) {
      acc.writeByte(0);
      serialize_PacketSyncStrongholdPos_Concretic(value, acc);
    } else {
      throw new IllegalStateException("Unexpected implementation of hohserg.endercompass.network.PacketSyncStrongholdPos: "+value.getClass().getName());
    }
  }

  PacketSyncStrongholdPos unserialize_PacketSyncStrongholdPos_Generic(ByteBuf buf) {
    byte concreteIndex = buf.readByte();
    if (false)  {
      return null;
    } else if (concreteIndex == 0) {
      return unserialize_PacketSyncStrongholdPos_Concretic(buf);
    } else {
      throw new IllegalStateException("Unexpected implementation of hohserg.endercompass.network.PacketSyncStrongholdPos: concreteIndex = "+concreteIndex);
    }
  }

  void serialize_PacketSyncStrongholdPos_Concretic(PacketSyncStrongholdPos value, ByteBuf acc) {
    serialize_Int_Generic(value.dimension, acc);
    serialize_BlockPos_Generic(value.pos, acc);
  }

  PacketSyncStrongholdPos unserialize_PacketSyncStrongholdPos_Concretic(ByteBuf buf) {
    PacketSyncStrongholdPos value = new PacketSyncStrongholdPos(unserialize_Int_Generic(buf), unserialize_BlockPos_Generic(buf));
    return value;
  }

  void serialize_BlockPos_Generic(BlockPos value, ByteBuf acc) {
    if (false)  {
      return;
    } else if (value instanceof BlockPos) {
      acc.writeByte(0);
      serialize_BlockPos_Concretic(value, acc);
    } else {
      throw new IllegalStateException("Unexpected implementation of net.minecraft.util.math.BlockPos: "+value.getClass().getName());
    }
  }

  BlockPos unserialize_BlockPos_Generic(ByteBuf buf) {
    byte concreteIndex = buf.readByte();
    if (false)  {
      return null;
    } else if (concreteIndex == 0) {
      return unserialize_BlockPos_Concretic(buf);
    } else {
      throw new IllegalStateException("Unexpected implementation of net.minecraft.util.math.BlockPos: concreteIndex = "+concreteIndex);
    }
  }

  void serialize_BlockPos_Concretic(BlockPos value, ByteBuf acc) {
    serialize_Int_Generic(value.getX(), acc);
    serialize_Int_Generic(value.getY(), acc);
    serialize_Int_Generic(value.getZ(), acc);
  }

  BlockPos unserialize_BlockPos_Concretic(ByteBuf buf) {
    BlockPos value = new BlockPos(unserialize_Int_Generic(buf), unserialize_Int_Generic(buf), unserialize_Int_Generic(buf));
    return value;
  }
}
